<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qbs.qdoc -->
  <title>Module Providers | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >Module Providers</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="custom-modules.html" />
  <link rel="next" href="howtos.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="custom-modules.html">Custom Modules and Items</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="howtos.html">How-tos</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#how-qbs-uses-module-providers">How Qbs Uses Module Providers</a></li>
<li class="level1"><a href="#parameterizing-module-providers">Parameterizing Module Providers</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Module Providers</h1>
<span class="subtitle"></span>
<!-- $$$module-providers.html-description -->
<div class="descr"> <a name="details"></a>
<p>There are use cases for which a pre-defined module is not flexible enough. For instance, the overall set of modules related to a certain task might depend on some information present on the local platform.</p>
<p><b>Note: </b>Module providers are an advanced concept that you will rarely need to use directly. Reading this section is not required for most people's everyday work.</p><a name="how-qbs-uses-module-providers"></a>
<h2 id="how-qbs-uses-module-providers">How Qbs Uses Module Providers</h2>
<p>If Qbs encounters a <a href="qml-qbslanguageitems-depends.html">Depends</a> item whose name does not match a known module, it checks whether such a module can be generated. This procedure works as follows:</p>
<ol class="1" type="1"><li>All <a href="qml-qbslanguageitems-project.html#qbsSearchPaths-prop">search paths</a> are scanned for a file called <code>module-providers/&lt;name&gt;/provider.qbs</code>, where <code>&lt;name&gt;</code> is the name of the dependency as specified in the <code>Depends</code> item. Multi-component names such as &quot;a.b&quot; are turned into nested directories, and each of them is scanned, starting with the deepest path. For instance, if the dependency's name is <code>a.b</code>, then Qbs will look for <code>a/b/provider.qbs</code> and then <code>a/provider.qbs</code>.</li>
<li>If such a file is found, it needs to contain a <a href="qml-qbslanguageitems-moduleprovider.html">ModuleProvider</a> item. This item is instantiated, which potentially leads to the creation of one or more modules, and Qbs retrieves the search paths to find these modules from the item. The details are described in the <a href="qml-qbslanguageitems-moduleprovider.html">ModuleProvider</a> documentation.</li>
<li>If a matching module provider was found and provided new search paths, a second attempt will be made to locate the dependency using the new paths. The search for a matching module provider ends as soon as one was found, regardless of whether it created any modules or not.</li>
<li>If no matching module provider was found in any of the search paths, Qbs will fall back to a generic module provider, which creates a module that attempts to locate the dependency via <code>pkg-config</code>. This fallback mechanism can be disabled in the respective <a href="qml-qbslanguageitems-depends.html#enableFallback-prop">Depends</a> item or globally via the <a href="cli-build.html#no-fallback-module-provider">--no-fallback-module-provider</a> option.</li>
</ol>
<a name="parameterizing-module-providers"></a>
<h2 id="parameterizing-module-providers">Parameterizing Module Providers</h2>
<p>You can pass information to module providers from the command line, via profiles or from within a product, in a similar way as you would do for modules. For instance, the following invocation of Qbs passes information to two module providers <code>a</code> and <code>b</code>:</p>
<pre class="cpp">

  $ qbs moduleProviders<span class="operator">.</span>a<span class="operator">.</span>p1:<span class="keyword">true</span> moduleProviders<span class="operator">.</span>a<span class="operator">.</span>p2:<span class="keyword">true</span> moduleProviders<span class="operator">.</span>b<span class="operator">.</span>p:<span class="keyword">false</span>

</pre>
<p>Qbs will set the properties of the respective module providers accordingly. In the above example, module provider <code>a</code> needs to declare two boolean properties <code>p1</code> and <code>p2</code>, and they will be set to <code>true</code> and <code>false</code>, respectively.</p>
</div>
<!-- @@@module-providers.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="custom-modules.html">Custom Modules and Items</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="howtos.html">How-tos</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
